<template lang="pug">
Card.x-camera-control(ref='card')
  template(#info="c" v-if='showControls')
    p
      | This is a live camera stream card.
    template(v-if='ptz')
      hr
      strong Pan/Tilt/Zoom control
      p
        | Some cameras offer Pan/Tilt/Zoom (PTZ) control, when available the #[i.fa.fa-cog]
        | button appears.

      p
        | To control the camera the associated card must be #[span.border-secondary.border.px-1 focused], by clicking on it
        | (a light halo and border is displayed around the card).

      p
        | PTZ control is achieved using the mouse #[i.fa.fa-mouse], clicking on the image to
        | pan and tilt and using the mouse-wheel to zoom. #[br]
        | a finer grained zoom is available by holding #[kbd Ctrl] whilst using the mouse-wheel.

      p
        | An advanced mode is available by pressing the #[i.fa.fa-cog(title='advanced')] button, it allows
        | direct control over the PTZ settings (focus, iris ...).

      p
        | The PTZ camera can be reset using the #[i.fa.fa-home(title='home')] button.

    hr
    strong Pause and Screenshots
    p
      | Video streams can be paused using the #[i.fa.fa-pause(title='pause')] button.#[br]
      | When triggering the pause a fixed image with maximum resolution the camera can offer
      | is displayed and can be downloaded using the #[i.fa.fa-download(title='download')] icon.

  template(#default)
    li.p-0.flex-grow-1.d-flex.h-100(key='cam' @wheel='onWheel($event)' @mousedown='onMouseDown()')
      BaseAnimationGroup.align-content-center.d-flex.flex-grow-1
        img.x-screenshot.m-auto(v-if='paused && screenshot' key='screenshot' :src='screenshot' alt='Screenshot failed')
        CameraCard.flex-grow-1(ref='cam' key='cam' v-show='!(paused && screenshot)'
          @click.native='moveToPointer($event)' @connected='showControls = $event'
          :showFps='true' :useWS='true' :title='camera' :description='description'
          :src='$makeUri($butils.currentUrl(), `/cameras/${group}/${camera}?closeOnError=false`).href()')
  template(#card-footer)
    li(v-if='advanced && canControl && showControls' key='advanced')
      .d-flex(v-if='ptz && position && limits')
        .row
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Pan
            input.w-100.x.ptz-slider.custom-range(ref='pan' :disabled='refreshing' type='range'
              :title='`Pan ${position.pan}`'
              :min='limits.MinPan' :max='limits.MaxPan'
              @change='move({ pan: Number($event.target.value) }, true)')
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Tilt
            input.w-100.x.ptz-slider.custom-range(ref='tilt' :disabled='refreshing' type='range'
              :title='`Tilt ${position.tilt}`'
              :min='limits.MinTilt' :max='limits.MaxTilt'
              @change='move({ tilt: Number($event.target.value) }, true)')
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Zoom
            input.w-100.x.ptz-slider.custom-range(ref='zoom' :disabled='refreshing' :value='position.zoom' type='range'
              :title='`Zoom ${position.zoom}`'
              :min='limits.MinZoom' :max='limits.MaxZoom'
              @change='move({ zoom: Number($event.target.value) }, true)')
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Brightness
            input.w-100.x.ptz-slider.custom-range(ref='brightness' :disabled='refreshing' :value='position.brightness' type='range'
              :title='`Brightness ${position.brightness}`'
              :min='limits.MinBrightness' :max='limits.MaxBrightness'
              @change='move({ brightness: Number($event.target.value) }, true)')
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Focus
            input.w-100.x.ptz-slider.custom-range(ref='focus' :disabled='refreshing || position.autofocus' :value='position.focus' type='range'
              :title='`Focus ${position.focus}`'
              :min='limits.MinFocus' :max='limits.MaxFocus'
              @change='move({ focus: Number($event.target.value) }, true)')
            BaseToggle.d-flex(ref='autofocus' :disabled='refreshing' :inEdit='true' @click.native.prevent='toggleCtrl("autofocus")' title='AutoFocus')
          .col-12.d-flex.align-items-center
            span(style='min-width: 5em;') Iris
            input.w-100.x.ptz-slider.custom-range(ref='iris' :disabled='refreshing || position.autoiris' :value='position.iris' type='range'
              :title='`Iris ${position.iris}`'
              :min='limits.MinIris' :max='limits.MaxIris'
              @change='move({ iris: Number($event.target.value) }, true)')
            BaseToggle.d-flex(ref='autoiris' :disabled='refreshing' :inEdit='true' @click.native.prevent='toggleCtrl("autoiris")' title='AutoIris')
        button.btn.btn-sm.btn-light.ml-2(:disabled='refreshing' @click='refreshAdvanced()')
          i.fa.fa-sync-alt
  template(#footer-bar="")
    BaseAnimationGroup.x-controls.d-flex.justify-content-center(v-if='showControls')
      .col-2(v-if='!(paused && screenshot) && ptz && canControl' key='home' title='home')
        button.btn.btn-sm.btn-light.w-100.h-100(@click='move({ tilt: 0, pan: 0, zoom: 0, autofocus: true, autoiris: true }, true)')
          i.fa.fa-home
      .col-2(v-if='paused && screenshot' key='download')
        a.btn.btn-sm.btn-light.w-100.h-100(:href='screenshot' :download='screenshotName' title='download')
          i.fa.fa-download
      .col-2(v-if='ptz && canControl' key='advanced')
        button.btn.btn-sm.w-100.h-100(:class='advanced ? "btn-dark" : "btn-light"' @click='toggleAdvanced()' title='advanced control')
          i.fa.fa-cog
      .col-2(key='pause')
        button.btn.btn-sm.w-100.h-100(:class='paused ? "btn-dark" : "btn-light"' @click='togglePause()' title='pause')
          i.fa.fa-pause

</template>
<script src='./CameraControl.vue.js' />
<style lang='scss'>
.x-screenshot {
  min-height: 10em;
}
.x-camera-control {
  .x-screenshot {
    max-width: 100%;
    max-height: 100%;
    height: 100%;
    width: auto;
    object-fit: contain;
  }
}
</style>
